--
-- config
local DEFAULT_DISPLAY_TOOLTIPS = true;


local old_alpha
local notooltips = not DEFAULT_DISPLAY_TOOLTIPS

function DragQueen_Print(msg)
   DEFAULT_CHAT_FRAME:AddMessage("<DragQueen> " .. msg);
end

--
-- slash command handler
function DragQueen_ShowUsage()
end

function DragQueen_SlashCommandHandler(msg)
   DragQueen_ShowUsage();
end

--
-- template event handlers
function DragQueen_Template_OnLoad(this)
   if not this or not this:GetParent() then
      return;
   end
   -- make the parent-frame movable
   this:GetParent():SetMovable(1);
   --set to parent width
   this:SetWidth(this:GetParent():GetWidth());
   --subtract HitRectInsets/AbsInset/right value of parent stored in bar id
   --only needed since there's no GetRightHitRectInset()
   local widthOffeset = this:GetID();
   if ( widthOffeset ) then
      this:SetWidth(this:GetWidth()-widthOffeset);
   end
   if this:GetParent():GetName() == "CharacterFrame" then
      this:SetFrameLevel(this:GetFrameLevel() + 4);
   end
end

function DragQueen_Template_OnEnter(this)
   if not notooltips then
      DragQueen_Tooltip:SetOwner(this, "ANCHOR_CURSOR");
      DragQueen_Tooltip:SetText("Left-Click to drag.");
   end
end

function DragQueen_Template_OnLeave(this)
   if not notooltips then
      DragQueen_Tooltip:Hide();
   end
end

function DragQueen_Template_OnMouseUp(this)
   if ( this:GetParent().isMoving ) then
      this:GetParent():StopMovingOrSizing();
      this:GetParent().isMoving = false;
   end
end

function DragQueen_Template_OnMouseDown(this)
   if ( arg1 == "LeftButton" ) then
      this:GetParent():StartMoving();
      this:GetParent().isMoving = true;
   end
end

function DragQueen_Template_OnShow(this)
end

function DragQueen_Template_OnHide(this)
   this:GetParent():ClearAllPoints();
   local i, container;
   for i=1,11 do
      container = getglobal("ContainerFrame"..i);
      container:ClearAllPoints();
   end
end

--
-- main event handlers
function DragQueen_OnEvent(event)
   if event == "VARIABLES_LOADED" then
      DragQueen_Print("Loaded. /dq for info.\n");
   end
end

function DragQueen_OnLoad(this)
   --this:RegisterEvent("VARIABLES_LOADED");

   SLASH_DRAGQUEEN1 = "/dragqueen";
   SLASH_DRAGQUEEN2 = "/dq";
   
   SlashCmdList["DRAGQUEEN"] = DragQueen_SlashCommandHandler;
end
