--
-- CONFIG
--
local PiraCore_Version = "11200.09"

--
-- LIB
--
function PiraCore_Print(msg)
   if msg then DEFAULT_CHAT_FRAME:AddMessage("<PiraCore> " .. msg)end
end

--
-- CASTING BAR
--
local old_alpha = 0

function PiraCore_CastingBar_Unlock()
   CastingBarFrame:Show()
   CT_CastBarFrame:Show()
   old_alpha = CastingBarFrame:GetAlpha()
   CastingBarFrame:SetAlpha(1)
end

function PiraCore_CastingBar_Lock()
   CastingBarFrame:Hide()
   CT_CastBarFrame:Hide()
   CastingBarFrame:SetAlpha(old_alpha)   
end

--
-- SLASH COMMANDS
--
function PiraCore_ShowUsage()
   PiraCore_Print("version " .. PiraCore_Version)
   PiraCore_Print("  /piramod <command>")
   PiraCore_Print("    unlockcastbar: show and unlock the castbar position")
   PiraCore_Print("    lockcastbar: lock and hide the castbar position") 
end

function PiraCore_SlashCommandHandler(msg)
   if not msg then PiraCore_ShowUsage() return end

   local args = {}
   local i = 1
   for w in string.gfind(msg, "[^%s]+") do
      args[i] = w
      i=i+1
   end   
   if i > 2 then PiraCore_ShowUsage() return end

   if args[1] == "unlockcastbar" then      
      PiraCore_CastingBar_Unlock()
      PiraCore_Print("castbar unlocked")
   elseif args[1] == "lockcastbar" then
      PiraCore_CastingBar_Lock()
      PiraCore_Print("castbar locked")
   else
      PiraCore_ShowUsage()
      return
   end
end

--
-- EVENTS
--
function PiraCore_OnLoad(this)
   this:RegisterEvent("VARIABLES_LOADED")

   SLASH_PIRACORE1 = "/piramod"
   
   SlashCmdList["PIRACORE"] = PiraCore_SlashCommandHandler
end
