
Zorlen_Rogue_FileBuildNumber = 670

--[[
  Zorlen Library - Started by Marcus S. Zarra
  
  4.15
		Fixed: unStealth()
  
  4.12
		isAdrenalineRushActive() added by Nosrac
		isBladeFlurryActive() added by Nosrac
		isEvasionActive() added by Nosrac
		isSprintActive() added by Nosrac
		isCripplingPoisonActive() added by Nosrac
		isDeadlyPoisonActive() added by Nosrac
		isInstantPoisonActive() added by Nosrac
		isMindnumbingPoisonActive() added by Nosrac
		isWoundPoisonActive() added by Nosrac
		isPoisonActive() added by BigRedBrent
  
  3.92
		castStealth() added by BigRedBrent
		unStealth() added by BigRedBrent
		castVanish() added by BigRedBrent
  
  3.78
		castFeint() added by Xek
		castEviscerate() added by Xek
		castRiposte() added by Xek
		castSliceAndDice() added by Xek
		isComboPoints(number) added by BigRedBrent

  3.70.00
		castColdBlood() added by Mainline

  3.10.00
		isSliceActive() added by Mizz
		isStealthActive() added by BigRedBrent
		isComboPointsFull() added by BigRedBrent
		Zorlen_CheapShotEnergyCost() added by BigRedBrent
		Zorlen_SinisterStrikeEnergyCost() added by Mizz
		castSinisterStrike() added by Mizz
		castBackstab() added by Mizz
		castKick() added by Mizz
		castCheapShot() added by BigRedBrent

  3.00  Rewrite by Wynn (Bleeding Hollow), break units into class functions.
		  
--]]


function isComboPointsFull()
	return isComboPoints(5)
end

function isComboPoints(number)
	if number then
		if GetComboPoints() == number then
			return true
		end
	elseif GetComboPoints() > 0 then
		return true
	end
	return false
end



function isStealthActive()
	return Zorlen_checkBuff("Ability_Stealth")
end

function isSliceActive()
	return Zorlen_checkBuff("Ability_Rogue_SliceDice")
end 

--Added by Nosrac
function isAdrenalineRushActive()
	local SpellName = LOCALIZATION_ZORLEN_AdrenalineRush
	return Zorlen_checkBuffByName(SpellName)
end

--Added by Nosrac
function isBladeFlurryActive()
	local SpellName = LOCALIZATION_ZORLEN_BladeFlurry
	return Zorlen_checkBuffByName(SpellName)
end

--Added by Nosrac
function isEvasionActive()
	local SpellName = LOCALIZATION_ZORLEN_Evasion
	return Zorlen_checkBuffByName(SpellName)
end

--Added by Nosrac
function isSprintActive()
	local SpellName = LOCALIZATION_ZORLEN_Sprint
	return Zorlen_checkBuffByName(SpellName)
end


--Added by Nosrac
function isCripplingPoisonActive()
	local SpellName = LOCALIZATION_ZORLEN_CripplingPoison
	return Zorlen_checkItemBuffByName(SpellName)
end

--Added by Nosrac
function isDeadlyPoisonActive()
	local SpellName = LOCALIZATION_ZORLEN_DeadlyPoison
	return Zorlen_checkItemBuffByName(SpellName)
end

--Added by Nosrac
function isInstantPoisonActive()
	local SpellName = LOCALIZATION_ZORLEN_InstantPoison
	return Zorlen_checkItemBuffByName(SpellName)
end

--Added by Nosrac
function isMindnumbingPoisonActive()
	local SpellName = LOCALIZATION_ZORLEN_MindnumbingPoison
	return Zorlen_checkItemBuffByName(SpellName)
end

--Added by Nosrac
function isWoundPoisonActive()
	local SpellName = LOCALIZATION_ZORLEN_WoundPoison
	return Zorlen_checkItemBuffByName(SpellName)
end

--Added by BigRedBrent
function isPoisonActive()
	if isCripplingPoisonActive() or isDeadlyPoisonActive() or isInstantPoisonActive() or isMindnumbingPoisonActive() or isWoundPoisonActive() then
		return true
	end
	return false
end

-- Returns the energy cost the CheapShot ability will need for it to cast (even if talent points are spent on it to lower its required energy cost).
-- Will return 0 if no rank of the ability has been learned from the Rouge Trainer.
function Zorlen_CheapShotEnergyCost()
	local t = Zorlen_GetTalentRank(LOCALIZATION_ZORLEN_ImprovedCheapShot)
	if (not Zorlen_IsSpellKnown(LOCALIZATION_ZORLEN_CheapShot)) then
		return 0
	else if (t == 2) then
		return 40
	else if (t == 1) then
		return 50
	else
		return 60
	end
	end
	end
end



-- Returns the energy cost the Sinister Strike ability will need for it to cast (even if talent points are spent on it to lower its required energy cost).
-- Will return 0 if no rank of the ability has been learned from the Rouge Trainer.
function Zorlen_SinisterStrikeEnergyCost()
	local t = Zorlen_GetTalentRank(LOCALIZATION_ZORLEN_ImprovedSinisterStrike)
	if (not Zorlen_IsSpellKnown(LOCALIZATION_ZORLEN_SinisterStrike)) then
		return 0
	else if (t == 2) then
		return 40
	else if (t == 1) then
		return 42
	else
		return 45
	end
	end
	end
end



function castSinisterStrike()
	local SpellName = LOCALIZATION_ZORLEN_SinisterStrike
	local ManaNeeded = Zorlen_SinisterStrikeEnergyCost()
	if not Zorlen_isMainHandEquipped() then
		return false
	end
	return Zorlen_CastCommonRegisteredSpell(nil, SpellName, nil, nil, ManaNeeded)
end



function castCheapShot()
	local SpellName = LOCALIZATION_ZORLEN_CheapShot
	local ManaNeeded = Zorlen_CheapShotEnergyCost()
	local DoBuffIncluded = 1
	local DoBuff = isStealthActive()
	if not Zorlen_isMainHandEquipped() then
		return false
	end
	return Zorlen_CastCommonRegisteredSpell(nil, SpellName, nil, nil, ManaNeeded, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, nil, DoBuffIncluded, DoBuff)
end



function castBackstab()
	local SpellName = LOCALIZATION_ZORLEN_Backstab
	local ManaNeeded = 60
	if not Zorlen_isMainHandDagger() then
		return false
	end
	return Zorlen_CastCommonRegisteredSpell(nil, SpellName, nil, nil, ManaNeeded)
end



function castKick()
	local SpellName = LOCALIZATION_ZORLEN_Kick
	local ManaNeeded = 25
	local TargetThatUsesManaNeeded = 1
	return Zorlen_CastCommonRegisteredSpell(nil, SpellName, nil, nil, ManaNeeded, nil, nil, nil, TargetThatUsesManaNeeded)
end



--Added by Mainline
function castColdBlood()
	local SpellName = LOCALIZATION_ZORLEN_ColdBlood
	local EnemyTargetNotNeeded = 1
	return Zorlen_CastCommonRegisteredSpell(nil, SpellName, nil, nil, nil, nil, EnemyTargetNotNeeded)
end




--Added by Xek
function castFeint()
	local SpellName = LOCALIZATION_ZORLEN_Feint
	local ManaNeeded = 20
	return Zorlen_CastCommonRegisteredSpell(nil, SpellName, nil, nil, ManaNeeded)
end

--Added by Xek
function castEviscerate()
	local SpellName = LOCALIZATION_ZORLEN_Eviscerate
	local ManaNeeded = 35
	if not isComboPoints() then
		return false
	end
	if not Zorlen_isMainHandEquipped() then
		return false
	end
	return Zorlen_CastCommonRegisteredSpell(nil, SpellName, nil, nil, ManaNeeded)
end

--Added by Xek
function castRiposte()
	local SpellName = LOCALIZATION_ZORLEN_Riposte
	local ManaNeeded = 10
	return Zorlen_CastCommonRegisteredSpell(nil, SpellName, nil, nil, ManaNeeded)
end

--Added by Xek
function castSliceAndDice()
	local SpellName = LOCALIZATION_ZORLEN_SliceAndDice
	local ManaNeeded = 25
	return Zorlen_CastCommonRegisteredSpell(nil, SpellName, nil, nil, ManaNeeded)
end


function castStealth()
	local SpellName = LOCALIZATION_ZORLEN_Stealth
	local EnemyTargetNotNeeded = 1
	if Zorlen_inCombat() or isStealthActive() then
		return
	end
	return Zorlen_CastCommonRegisteredSpell(nil, SpellName, nil, nil, nil, nil, EnemyTargetNotNeeded)
end

function unStealth()
	return Zorlen_CancelSelfBuff("Ability_Stealth")
end

function castVanish()
	local SpellName = LOCALIZATION_ZORLEN_Vanish
	local EnemyTargetNotNeeded = 1
	return Zorlen_CastCommonRegisteredSpell(nil, SpellName, nil, nil, nil, nil, EnemyTargetNotNeeded)
end


